package org.lossywav.algorithm;
//==============================================================================
//
//    lossyWAV: Added noise WAV bit reduction method by David Robinson;
//              Noise shaping coefficients by Sebastian Gesemann;
//
//    Copyright (C) 2007, 2008 Nick Currie, Copyleft.
//    Copyright (C) 2008, C# port by Greg Chudov.
//    Copyright (C) 2008, Java port by Josep Maria Antoln
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
//    Contact: lossywav <at> yahoo <dot> com

/**
 * Status of the FFT analysis.
 * @author JosepMa
 */
public class FFTStatus {
	public short btr;
	public short start;
	/**
	 * getter of btr
	 * @return the btr
	 */
	public short getBtr() {
		return btr;
	}
	/**
	 * setter of btr
	 * @param btr the btr to set
	 */
	public void setBtr(short btr) {
		this.btr = btr;
	}
	/**
	 * getter of start
	 * @return the start
	 */
	public short getStart() {
		return start;
	}
	/**
	 * setter of start
	 * @param start the start to set
	 */
	public void setStart(short start) {
		this.start = start;
	}
	/**
	 * Copies the values of an existing FFTStatus to this one.
	 * @param status FFTStatus
	 */
	public void copyFrom(FFTStatus status) {
		this.btr = status.btr;
		this.start = status.start;
	}
}
