package org.lossywav.algorithm;
//==============================================================================
//
//    lossyWAV: Added noise WAV bit reduction method by David Robinson;
//              Noise shaping coefficients by Sebastian Gesemann;
//
//    Copyright (C) 2007, 2008 Nick Currie, Copyleft.
//    Copyright (C) 2008, C# port by Greg Chudov.
//    Copyright (C) 2008, Java port by Josep Maria Antoln
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
//    Contact: lossywav <at> yahoo <dot> com
/**
 * Status of the overall lossyWav process being executed.
 * @author JosepMa
 */
public class LossyWavStatus {
	private boolean initialized = false;
	private int clippedSamples;
	private int processedBlocks;
	private int overallBitsRemoved;
	private int overallBitsLost;

	public boolean isInitialized() {
		return initialized;
	}
	public void setInitialized(boolean initialized) {
		this.initialized = initialized;
	}
	public int getClippedSamples() {
		return clippedSamples;
	}
	public void setClippedSamples(int clippedSamples) {
		this.clippedSamples = clippedSamples;
	}
	public int addClippedSamples(int clippedSamples) {
		return this.clippedSamples += clippedSamples;
	}
	/**
	 * getter of processedBlocks
	 * @return the processedBlocks
	 */
	public int getProcessedBlocks() {
		return processedBlocks;
	}
	/**
	 * setter of processedBlocks
	 * @param processedBlocks the processedBlocks to set
	 */
	public void setProcessedBlocks(int processedBlocks) {
		this.processedBlocks = processedBlocks;
	}
	public int increaseProcessedBlocks(int blocksProcessed) {
		return this.processedBlocks += blocksProcessed;
	}
	public int getOverallBitsRemoved() {
		return overallBitsRemoved;
	}
	public void setOverallBitsRemoved(int overallBitsRemoved) {
		this.overallBitsRemoved = overallBitsRemoved;
	}
	public int addOverallBitsRemoved(int overallBitsRemoved) {
		return this.overallBitsRemoved += overallBitsRemoved;
	}
	public int getOverallBitsLost() {
		return overallBitsLost;
	}
	public void setOverallBitsLost(int overallBitsLost) {
		this.overallBitsLost = overallBitsLost;
	}
	public int addOverallBitsLost(int overallBitsLost) {
		return this.overallBitsLost += overallBitsLost;
	}

	public void reset() {
		processedBlocks = 1;
		overallBitsRemoved = 0;
		overallBitsLost = 0;
		clippedSamples = 0;
	}
}
