package org.lossywav.frontend;

import java.io.PrintStream;
import java.text.ParseException;

import org.lossywav.util.Constants;

public class ConsoleUtil {

	public static boolean isHelpParam(String arg) {
		final String lower = arg.toLowerCase();
		boolean found = false;
	   if ("-v".equals(lower) || "--version".equals(lower)) {
		   System.out.println(Constants.JLOSSYWAV_TAG);
		   found = true;
	   }
	   else if ("-h".equals(lower) || "--help".equals(lower)) {
		   PrintStringArray(ConstConsole.LOSSY_WAV_HEAD);
		   PrintStringArray(ConstConsole.LOSSYWAV_GPL);
		   PrintStringArray(ConstConsole.LOSSYWAV_STANDARD_HELP);
		   PrintStringArray(ConstConsole.LOSSYWAV_SPECIAL_THANKS);
		   found = true;
	   }
	   else if ("-l".equals(lower) || "--longhelp".equals(lower)) {
		   PrintStringArray(ConstConsole.LOSSY_WAV_HEAD);
		   PrintStringArray(ConstConsole.LOSSYWAV_GPL);
		   PrintStringArray(ConstConsole.LOSSYWAV_PROCESS_DESCRIPTION);
		   PrintStringArray(ConstConsole.LOSSYWAV_STANDARD_HELP);
		   PrintStringArray(ConstConsole.LOSSYWAV_ADVANCED_HELP);
		   PrintStringArray(ConstConsole.LOSSYWAV_SPECIAL_THANKS);
		   found = true;
	   }
	   return found;
	}

	public static void PrintStringArray(String[] string) {
		PrintStringArray(string, System.err);
	}

	public static void PrintStringArray(String[] strings, PrintStream out) {
		for(String string: strings) {
			out.println(string);
		}
	}

	public static void checkValidRange(String param, double check,
			double min, double max) throws ParseException {
				if (check < min || max < check) {
					throw new ParseException(String.format(
							ConstConsole.ERRORS_OUT_OF_RANGE_DOUBLE, param, check, min, max), 0);
				}
			}

	public static void checkValidRange(String param, int check,
			int min, int max) throws ParseException {
				if (check < min || max < check) {
					throw new ParseException(String.format(
							ConstConsole.ERRORS_OUT_OF_RANGE_INT, param, check, min, max), 0);
				}
			}
}