package org.lossywav.frontend;

import org.lossywav.util.Constants;
//TODO: The commented lines imply that they are not implemented yet.
public class ConstConsole {
	    //12345678901234567890123456789012345678901234567890123456789012345678901234567890
	  public static final String[] LOSSY_WAV_HEAD = { 
		  Constants.JLOSSYWAV_TAG + ", Copyright (C) 2008,2009 Josep Maria Antolin. Copyleft." ,
	      "Based on " + Constants.LOSSYWAV_TAG + ", Copyright (C) 2007,2008,2009 Nick Currie. Copyleft." ,
	      "This is free software under the GNU GPLv3+ license; There is NO WARRANTY, to " +
	      "the extent permitted by law. <http://www.gnu.org/licenses/> for details." };
	  
         //12345678901234567890123456789012345678901234567890123456789012345678901234567890
	  public static final String[] LOSSYWAV_GPL = {
          "This program is free software: you can redistribute it and/or modify it under "+
          "the terms of the GNU General Public License as published by the Free Software "+
          "Foundation, either version 3 of the License, or (at your option) any later "+
          "version." , 
    	  "This program is distributed in the hope that it will be useful,but WITHOUT ANY "+
          "WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A "+
          "PARTICULAR PURPOSE.  See the GNU General Public License for more details." ,
    	  "You should have received a copy of the GNU General Public License along with "+
          "this program.  If not, see <http://www.gnu.org/licenses/>." };

         //12345678901234567890123456789012345678901234567890123456789012345678901234567890
	  public static final String[] LOSSYWAV_PROCESS_DESCRIPTION = {
          "Process Description:" ,
          "lossyWAV is a near lossless audio processor which dynamically reduces the "+
          "bitdepth of the signal on a block-by-block basis. Bitdepth reduction adds white "+
          "noise to the processed output. The amount of permissible added noise is based "+
          "on analysis of the signal levels in the frequency range 20Hz to 16kHz." ,
    	  "If signals above the upper limiting frequency are at an even lower level, they "+
    	  "can be swamped by the added noise. This is usually inaudible, but the behaviour "+
    	  "can be changed by specifying a higher --limit (in the range 16kHz to 20kHz)." ,
    	  "For many audio signals there is little content at very high frequencies and "+
    	  "forcing lossyWAV to keep the added noise level lower than the content at these "+
    	  "frequencies can increase the bitrate dramatically for no perceptible benefit." };

	  public static final String[] LOSSYWAV_SYNTAX = {
		  "Syntax: java -jar lossyWAV <wavfilename>",
		  "Type 'java -jar lossyWAV --help' for more details."};

         //12345678901234567890123456789012345678901234567890123456789012345678901234567890
	  public static final String[] LOSSYWAV_STANDARD_HELP = {
          "Usage   : java -jar lossyWAV [options] <input wav file>" ,
          "Example : java -jar lossyWAV musicfile.wav" ,
          "Quality Options:" ,
          "-I, --insane         highest quality output, suitable for transcoding;" ,
          "-E, --extreme        high quality output, also suitable for transcoding;",
          "-S, --standard       default quality output, considered to be transparent;",
          "-P, --portable       good quality output for DAP use, not fully transparent.",
          "-Z, --zero           lowest quality preset, probably contains artifacts.",
          //12345678901234567890123456789012345678901234567890123456789012345678901234567890
          "Standard Options:",
          "-C, --correction     write correction file for processed WAV file; default=off.",
          "-f, --force          forcibly over-write output file if it exists; default=off.",
          "-h, --help           display help.",
          "-L, --longhelp       display extended help.",
//          "-M, --merge          merge existing lossy.wav and lwcdf.wav files.",
          "-o, --outdir <t>     destination directory for the output file(s).",
          "-v, --version        display the lossyWAV version number.",
//          "-w, --writetolog     create (or add to) lossyWAV.log in the output directory."
          };

	  	 //12345678901234567890123456789012345678901234567890123456789012345678901234567890
	  public static final String[] LOSSYWAV_ADVANCED_HELP = {
		  "Advanced Options:",
//       "-                    if filename=\"-\" then WAV input is taken from STDIN.",
       "-a, --analyses       set number of FFT analysis lengths, (2<=n<=5), default=2.",
//       "    --blockdist      show distribution of lowest significant bit of input",
//       "                     codec-blocks and bit-removed codec-blocks.",
//       "-c, --check          check if WAV file has already been processed; default=off.",
//       "                     errorlevel=16 if already processed, 0 if not.",
//       "-F, --fftw           use libfftw3-3.dll for FFT analyses.",
       "-l, --limit <n>      set upper frequency limit to be used in analyses to n Hz;",
       "                     (16000<=n<=20000), default = 16000.",
//       "    --linkchannels   Revert to original single bits-to-remove value for all",
//       "                     channels rather than channel dependent bits-to-remove.",
       "    --maxclips <n>   set max. number of acceptable clips per channel per codec",
       "                     block. (0<=n<=16) Default = (3,3,3,3,2,1,0,0,0,0,0).",
//       "-m, --midside        analyse 2 channel audio for mid/side content.",
       "-q, --quality <n>    quality preset (-4.000<=n<=10.000); (10=highest, 0=lowest;",
       "                     default = --standard = 5; --insane = 10; --extreme = 7.5;",
       "                     --portable = 2.5; --zero = 0; --nasty = -2; --awful=-4)",
//       "    --sampledist     show distribution of lowest significant bit of input",
//       "                     samples and bit-removed samples.",
       "    --scale <n>      scaling factor from WaveGain, etc; (0.0<n<=8.0),default=1.",
       "-s, --shaping <n>    enable fixed noise shaping; (0.00<=n<=1.00); default=q/10;",
       "                     0.00 = off, 1.00 = 100% effectiveness, 0.50 = 50%, etc.",
//       "    --stdout         write processed WAV output to STDOUT.",
//       "    --stdinname <t>  pseudo filename to use when input from STDIN.",
	  	 //12345678901234567890123456789012345678901234567890123456789012345678901234567890
       "System Options:",
       "-B, --below          set process priority to below normal.",
//       "-d, --detail         enable detailed bits-to-remove information output mode",
       "    --low            set process priority to low.",
//       "-n, --nowarnings     suppress lossyWAV warnings.",
//       "-Q, --quiet          significantly reduce screen output.",
//       "    --silent         no screen output.",
	  	 //12345678901234567890123456789012345678901234567890123456789012345678901234567890
       "Testing Quality Options:",
       "-A, --awful          quality preset for testing purposes only (equiv. -q -4).",
       "-N, --nasty          quality preset for testing purposes only (equiv. -q -2).",
       "Testing Advanced Options:",
       "-U, --underlap <n>   enable experimental underlap mode, 1<=n<=8; default=1.",
       "-X, --sortspread     enable experimental spreading; default=off."
       };

	  //12345678901234567890123456789012345678901234567890123456789012345678901234567890
	  public static final String[] LOSSYWAV_SPECIAL_THANKS = {
       "Special thanks go to:",
       "David Robinson       for the publication of his lossyFLAC method, guidance, and",
       "                     the motivation to implement his method as lossyWAV.",
       "Horst Albrecht       for ABX testing, valuable support in tuning the internal",
       "                     presets, constructive criticism and all the feedback.",
       "Sebastian Gesemann   for the noise shaping coefficients and help in using them",
       "                     in the lossyWAV noise shaping implementation.",
       "Matteo Frigo and     for the excellent libfftw3-3.dll contained in the FFTW",
       "Steven G Johnson     distribution (v3.2.1).",
       "Mark G Beckett       for the Delphi unit that provides an interface to the",
       "(Univ. of Edinburgh) relevant fftw routines in libfftw3-3.dll.",
       "Don Cross            for the Complex-FFT algorithm originally used." };

	  public static final double[] QUALITY_SYNONYMS_VALS = {-4.0,-2.0, 0.0, 2.5, 5.0, 7.5,10.0};
	  public static final String[] QUALITY_SYNONYMS_SHORT = {"-A","-N","-Z","-P","-S","-E","-I"};
	  public static final String[] QUALITY_SYNONYMS_LONG = {"--awful","--nasty","--zero","--portable","--standard","--extreme","--insane"};
	  public static final int NUM_QUALITY_SYNONYMS = QUALITY_SYNONYMS_VALS.length;
	  
	  public static final String ERRORS_OUT_OF_RANGE_DOUBLE = "The %s parameter with value %.02f is out of range [%.02f..%.02f].";
	  public static final String ERRORS_OUT_OF_RANGE_INT = "The %s parameter with value %d is out of range [%d..%d].";
	  
	  public static final String ERRORS_VAL_MISSING_FOR = "The value for this argument is missing: ";
	  public static final String ERRORS_NONNUMBER = "The value supplied for this argument is not a number: ";
	  public static final String ERRORS_PARSING_UNKNOWN = "Unknown argument found while parsing: ";
}
